; Eric Lundell
; 17 Dec 2010
; Project 2, CS 301 Assembly Language
; Link with abeep.asm
;
; This program will read in a specifc format file and beep the internal speaker at a defined pitch.
; File format is described in the files themselves and the README.
;
; To compile this program most easily, use the shell Proj.sh.  This will compile both the .cpp and .asm file.
; To run you must use sudo:
;
; 	sudo ./abeep musicfile.txt
;


; // Function and varible found in the .cpp file
; extern "C" void abeep_asm(void);
; extern "C" int fda;  // This is used so that we don't have to use a parameter call

global fda_asm
global abeep_asm

section .text
abeep_asm:

	push ebx ; need ebx for system call    

	; console_fd = open("/dev/console", O_WRONLY)
	mov edx, 0  	; mode not set
	mov ecx, 1  	; flag O_WRONLY = 1
	mov ebx, name 	; console device
	mov eax, 0x5  	; open syscall = 5
	int 0x80  	; syscall

	;mov [fda_asm], eax  ; move file descriptor into variable fda

	; #define CLOCK_TICK_RATE 1193180 (0x1234DC)
	; freq: C = 261.6, E = 329.6  -> CLOCK_TICK_RATE/freq = { 4561 (0x11D1), 3620 (0xE24)}
	; ioctl(console_fd, KIOCSOUND, freq != 0 ? (int)(CLOCK_TICK_RATE/freq) : freq)

	;mov edx, 0x11D1    ; clock rate / middle c
	;mov ecx, 0x4b2f   ; KIOCSOUND: 9247
	;mov ebx, eax      ; file descriptor from previous open function 
	;mov eax, 0x54     ; ioctl
	;int 0x80

	mov [fda_asm], eax  ; move file descriptor into variable fda

 	pop ebx
 	ret

section .data
	name: db '/dev/console', 0
	fda_asm: dd -1

